package com.link.core.basic.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.link.base.user.model.CoreUser;
import com.link.core.basic.query.Filter;
import com.link.core.basic.query.QueryParams;
import com.link.core.util.CoreYmlConstants;
import com.link.core.util.DateUtil;
import com.link.core.util.ReflectUtil;
import com.link.core.util.StringUtils;
import com.link.core.util.UserUtil;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;
import javax.servlet.http.HttpServletRequest;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.BeanUtils;

public class BasicModel implements Serializable {
   private static final long serialVersionUID = 8900223672391323403L;
   private static final Logger logger = LogManager.getLogger(BasicModel.class);
   private QueryParams qps;
   private List<Filter> filterList;
   private String id;
   private String createdBy;
   private String created;
   private String lastUpdated;
   private String lastUpdatedBy;
   private Long corpid;
   private String corpName;
   private String orgId;
   private String orgName;
   private String postnId;
   private String postnName;
   private String positionType;
   @JsonIgnore
   private String anonymousFlag;
   private Long loginCorpId;
   private String row_status;
   private Integer page = 1;
   private Integer rows = 10000;
   private Integer total = -1;
   private Integer totalPage = -1;
   private Integer startRow = 0;
   private Integer endRow = 0;
   private Boolean totalFlag = false;
   private Boolean pageFlag = true;
   private Boolean onlyCountFlag = false;
   @JsonIgnore
   private Boolean selectOneFlag = true;
   private String isDefault;
   private String mvgMapperName;
   private String mvgParentId;
   private String oauth;
   @JsonIgnore
   private String conditionSql;
   private String security;
   private String searchText;
   private String securityModel;
   private String integrationId;
   private String privateAddr;
   @JsonIgnore
   private String topOauth = "ALL";
   @JsonIgnore
   private String sqlAndCorpId;
   private String login;
   private Integer currentCount;
   private String filterType;
   private String filterParm1;
   private String filterParm2;
   private String filterParm3;
   private List<String> filterParms;
   private String basicOrgId;
   private String basicPostnId;
   private String loginType;
   private Integer rowVersion;
   private String stayFields;
   @JsonIgnore
   private String skipFields;
   @JsonIgnore
   private String stayFieldsFlag;
   private String queryFields;
   private String attr1;
   private String attr2;
   private String attr3;
   private String attr4;
   private String attr5;
   private String attr6;
   private String attr7;
   private static final Pattern PATTERN = Pattern.compile("\\[.*\\]");
   private Boolean selectedFlag = false;
   private String updateFields;
   private String filterOperator;
   private List<Map<String, String>> reportResult;
   private String linkRequestId;
   private String distinctFields;
   private String reloadCache = "N";
   private String orgSecuritySourceId;
   private String postnSecuritySourceId;
   private String exportMethod;
   private String exportMethodParam;
   private int exportTotal = -1;
   private Long lastId = -1L;
   private String esIndex;
   private List<String> esIndexList;
   private String esScrollId;
   private Boolean esScrollFlag = false;
   private String esOauth;
   private String esIndexAlias;
   private String esDocShipFlag;
   private String esDocShipMark;
   private String cacheParam;
   private String groupFields;
   private String aggregationField;
   private String aggregationType;
   private String aggrResultValue;
   private boolean streamFlag;

   public String getAggrResultValue() {
      return this.aggrResultValue;
   }

   public void setAggrResultValue(String aggrResultValue) {
      this.aggrResultValue = aggrResultValue;
   }

   public String getGroupFields() {
      return this.groupFields;
   }

   public void setGroupFields(String groupFields) {
      this.groupFields = groupFields;
   }

   public String getAggregationField() {
      return this.aggregationField;
   }

   public void setAggregationField(String aggregationField) {
      this.aggregationField = aggregationField;
   }

   public String getAggregationType() {
      return this.aggregationType;
   }

   public void setAggregationType(String aggregationType) {
      this.aggregationType = aggregationType;
   }

   public String getEsIndexAlias() {
      return this.esIndexAlias;
   }

   public void setEsIndexAlias(String esIndexAlias) {
      this.esIndexAlias = esIndexAlias;
   }

   public String getEsOauth() {
      return this.esOauth;
   }

   public void setEsOauth(String esOauth) {
      this.esOauth = esOauth;
   }

   public Boolean getEsScrollFlag() {
      return this.esScrollFlag;
   }

   public void setEsScrollFlag(Boolean esScrollFlag) {
      this.esScrollFlag = esScrollFlag;
   }

   public String getEsIndex() {
      return this.esIndex;
   }

   public void setEsIndex(String esIndex) {
      this.esIndex = esIndex;
   }

   public List<String> getEsIndexList() {
      return this.esIndexList;
   }

   public void setEsIndexList(List<String> esIndexList) {
      this.esIndexList = esIndexList;
   }

   public String getEsScrollId() {
      return this.esScrollId;
   }

   public void setEsScrollId(String esScrollId) {
      this.esScrollId = esScrollId;
   }

   @JsonIgnore
   public String getQueryFields() {
      return this.queryFields;
   }

   public void setQueryFields(String queryFields) {
      this.queryFields = queryFields;
   }

   public String getDistinctFields() {
      return this.distinctFields;
   }

   public void setDistinctFields(String distinctFields) {
      this.distinctFields = distinctFields;
   }

   public String getLinkRequestId() {
      return this.linkRequestId;
   }

   public void setLinkRequestId(String linkRequestId) {
      this.linkRequestId = linkRequestId;
   }

   public String getIntegrationId() {
      return this.integrationId;
   }

   public void setIntegrationId(String integrationId) {
      this.integrationId = integrationId;
   }

   public Boolean getSelectOneFlag() {
      return this.selectOneFlag;
   }

   public void setSelectOneFlag(Boolean selectOneFlag) {
      this.selectOneFlag = selectOneFlag;
   }

   public String getSearchText() {
      return this.searchText;
   }

   public void setSearchText(String searchText) {
      this.searchText = searchText;
   }

   public String getSecurityModel() {
      return this.securityModel;
   }

   public void setSecurityModel(String securityModel) {
      this.securityModel = securityModel;
   }

   public String getSecurity() {
      return this.security;
   }

   public void setSecurity(String security) {
      this.security = security;
   }

   public String getStayFieldsFlag() {
      return this.stayFieldsFlag;
   }

   public void setStayFieldsFlag(String stayFieldsFlag) {
      this.stayFieldsFlag = stayFieldsFlag;
   }

   @JsonIgnore
   public String getStayFields() {
      return this.stayFields;
   }

   public void setStayFields(String stayFields) {
      this.stayFields = stayFields;
   }

   public String getSkipFields() {
      return this.skipFields;
   }

   public void setSkipFields(String skipFields) {
      this.skipFields = skipFields;
   }

   public String getConditionSql() {
      return this.conditionSql;
   }

   public void setConditionSql(String conditionSql) {
      this.conditionSql = conditionSql;
   }

   @JsonIgnore
   public Boolean getPageFlag() {
      return this.pageFlag;
   }

   public void setPageFlag(Boolean pageFlag) {
      this.pageFlag = pageFlag;
   }

   @JsonIgnore
   public Boolean getOnlyCountFlag() {
      return this.onlyCountFlag;
   }

   public void setOnlyCountFlag(Boolean onlyCountFlag) {
      this.onlyCountFlag = onlyCountFlag;
   }

   public String getAttr1() {
      return this.attr1;
   }

   public void setAttr1(String attr1) {
      this.attr1 = attr1;
   }

   public String getAttr2() {
      return this.attr2;
   }

   public void setAttr2(String attr2) {
      this.attr2 = attr2;
   }

   public String getAttr3() {
      return this.attr3;
   }

   public void setAttr3(String attr3) {
      this.attr3 = attr3;
   }

   public String getAttr4() {
      return this.attr4;
   }

   public void setAttr4(String attr4) {
      this.attr4 = attr4;
   }

   public String getAttr5() {
      return this.attr5;
   }

   public void setAttr5(String attr5) {
      this.attr5 = attr5;
   }

   public String getAttr6() {
      return this.attr6;
   }

   public void setAttr6(String attr6) {
      this.attr6 = attr6;
   }

   public String getAttr7() {
      return this.attr7;
   }

   public void setAttr7(String attr7) {
      this.attr7 = attr7;
   }

   public String getMvgMapperName() {
      return this.mvgMapperName;
   }

   public void setMvgMapperName(String mvgMapperName) {
      this.mvgMapperName = mvgMapperName;
   }

   public String getMvgParentId() {
      return this.mvgParentId;
   }

   public void setMvgParentId(String mvgParentId) {
      this.mvgParentId = mvgParentId;
   }

   @JsonIgnore
   public Boolean getTotalFlag() {
      return this.totalFlag;
   }

   public void setTotalFlag(Boolean totalFlag) {
      this.totalFlag = totalFlag;
   }

   public void setTotalPage(Integer totalPage) {
      this.totalPage = totalPage;
   }

   @JsonIgnore
   public Integer getTotalPage() {
      if (this.page == 1) {
         this.totalPage = this.total / this.rows;
         if (this.total % this.rows != 0) {
            Integer var1 = this.totalPage;
            Integer var2 = this.totalPage = this.totalPage + 1;
         }
      }

      return this.totalPage;
   }

   @JsonIgnore
   public Integer getStartRow() {
      if (this.page <= 0) {
         return this.startRow;
      } else {
         this.startRow = (this.page - 1) * this.rows + 1;
         return this.startRow;
      }
   }

   @JsonIgnore
   public Integer getEndRow() {
      if (this.page > 0) {
         this.endRow = this.page * this.rows;
      }

      return this.endRow;
   }

   @JsonIgnore
   public Integer getPage() {
      return this.page;
   }

   public void setPage(Integer page) {
      this.page = page;
   }

   @JsonIgnore
   public Integer getRows() {
      return this.rows;
   }

   public void setRows(Integer rows) {
      this.rows = rows;
   }

   public Integer getTotal() {
      return this.total;
   }

   public void setTotal(Integer total) {
      this.total = total;
   }

   public Long getLoginCorpId() {
      if (this.loginCorpId != null) {
         return this.loginCorpId;
      } else if ("Y".equals(this.anonymousFlag) && UserUtil.getUser() == null) {
         return 100L;
      } else {
         CoreUser user = UserUtil.getUser();
         return null == user ? null : user.getCorpid();
      }
   }

   public void setLoginCorpId(Long loginCorpId) {
      this.loginCorpId = loginCorpId;
   }

   public Long getCorpid() {
      return this.corpid;
   }

   public void setCorpid(Long corpid) {
      this.corpid = corpid;
   }

   public String getId() {
      return this.id;
   }

   public void setId(String id) {
      this.id = id;
   }

   public String getCreatedBy() {
      return this.createdBy;
   }

   public void setCreatedBy(String createdBy) {
      this.createdBy = createdBy;
   }

   public String getCreated() {
      return this.created;
   }

   public String getCreated(int length) {
      try {
         return length <= 0 ? this.created : this.created.substring(0, 16);
      } catch (Exception var3) {
         return this.created;
      }
   }

   public void setCreated(String created) {
      this.created = created;
   }

   public String getLastUpdated() {
      return this.lastUpdated;
   }

   public String getLastUpdated(int length) {
      try {
         return length <= 0 ? this.lastUpdated : this.lastUpdated.substring(0, 16);
      } catch (Exception var3) {
         return this.lastUpdated;
      }
   }

   public void setLastUpdated(String lastUpdated) {
      this.lastUpdated = lastUpdated;
   }

   public String getLastUpdatedBy() {
      return this.lastUpdatedBy;
   }

   public void setLastUpdatedBy(String lastUpdatedBy) {
      this.lastUpdatedBy = lastUpdatedBy;
   }

   public void installCreateUpdateData() {
      CoreUser user = UserUtil.getUser();
      this.created = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      this.lastUpdated = this.created;
      this.createdBy = user == null ? "0" : user.getId();
      this.lastUpdatedBy = this.createdBy;
      if (this.getCorpid() == null) {
         this.corpid = user == null ? 0L : user.getCorpid();
      }

   }

   public void installAnonymousCreateUpdateData() {
      this.created = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      this.lastUpdated = this.created;
      if (this.getAnonymousFlag() == null || "N".equals(this.getAnonymousFlag().toUpperCase())) {
         this.setAnonymousFlag("noMatchId");
      }

      this.createdBy = "0";
      this.lastUpdatedBy = this.createdBy;
   }

   public void installUpdateData() {
      CoreUser user = UserUtil.getUser();
      this.lastUpdated = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      this.lastUpdatedBy = user == null ? "0" : user.getId();
      if (this.getCorpid() == null) {
         this.corpid = user == null ? 0L : user.getCorpid();
      }

   }

   public void installAnonymousUpdateData() {
      this.lastUpdated = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      if (this.getAnonymousFlag() == null || "N".equals(this.getAnonymousFlag().toUpperCase())) {
         this.setAnonymousFlag("noMatchId");
      }

      this.lastUpdatedBy = "0";
   }

   public String getAnonymousFlag() {
      return this.anonymousFlag;
   }

   public void setAnonymousFlag(String anonymousFlag) {
      this.anonymousFlag = anonymousFlag;
   }

   public String getOrgId() {
      return this.orgId;
   }

   public void setOrgId(String orgId) {
      this.orgId = orgId;
   }

   public String getOrgName() {
      return this.orgName;
   }

   public void setOrgName(String orgName) {
      this.orgName = orgName;
   }

   public String getPostnId() {
      return this.postnId;
   }

   public void setPostnId(String postnId) {
      this.postnId = postnId;
   }

   public String getPostnName() {
      return this.postnName;
   }

   public void setPostnName(String postnName) {
      this.postnName = postnName;
   }

   public String getRow_status() {
      return this.row_status;
   }

   public void setRow_status(String row_status) {
      this.row_status = row_status;
   }

   public void preDealSecurity(HttpServletRequest request) {
      String oauthFlag = request.getParameter("oauthFlag");
      if (!StringUtils.equals(oauthFlag, "true")) {
         this.oauth = "ALL";
      }
   }

   public String getOauth() {
      return this.oauth;
   }

   public void setOauth(String oauth) {
      this.oauth = oauth;
   }

   public String getIsDefault() {
      return this.isDefault;
   }

   public void setIsDefault(String isDefault) {
      this.isDefault = isDefault;
   }

   public static <T extends BasicModel> T transformClass(T entity, QueryParams qps) {
      Class clz = entity.getClass();
      qps.invokePreFilterAndSorter();
      BeanUtils.copyProperties(qps, entity);
      entity.setOauth(qps.getOauth());
      entity.setQps(qps);
      return entity;
   }

   public static <T extends BasicModel> T transformClass(Class<T> clz, QueryParams qps) {
      T entity = null;

      try {
         entity = (BasicModel)clz.newInstance();
      } catch (InstantiationException var4) {
         InstantiationException e = var4;
         logger.error("BasicModel捕获异常: ", e);
      } catch (IllegalAccessException var5) {
         IllegalAccessException e = var5;
         logger.error("BasicModel捕获异常: ", e);
      }

      return null != entity ? transformClass(entity, qps) : null;
   }

   public static Object transformClassByObj(Object entity, QueryParams qps) throws Exception {
      qps.invokePreFilterAndSorter();
      BeanUtils.copyProperties(qps, entity);
      ReflectUtil.invokeSetter(entity, "oauth", qps.getOauth(), entity.getClass());
      ReflectUtil.invokeSetter(entity, "qps", qps, entity.getClass());
      return entity;
   }

   public String getCorpName() {
      return this.corpName;
   }

   public void setCorpName(String corpName) {
      this.corpName = corpName;
   }

   public void setStartRow(Integer startRow) {
      this.startRow = startRow;
   }

   public void setEndRow(Integer endRow) {
      this.endRow = endRow;
   }

   public void interfaceCreateData(String createdBy, String lastUpdatedBy, Long corpid) {
      this.created = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      this.lastUpdated = this.created;
      this.createdBy = createdBy;
      this.lastUpdatedBy = lastUpdatedBy;
      this.corpid = corpid;
      this.loginCorpId = corpid;
   }

   public void interfaceUpdateData(String lastUpdatedBy) {
      this.lastUpdated = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      this.lastUpdatedBy = lastUpdatedBy;
   }

   public String getPrivateAddr() {
      if (this.privateAddr != null && !"".equals(this.privateAddr)) {
         return this.privateAddr;
      } else if ("Y".equals(this.anonymousFlag) && UserUtil.getUser() == null) {
         return this.privateAddr;
      } else {
         CoreUser user = UserUtil.getUser();
         return null == user ? null : user.getUserPrivateAddr();
      }
   }

   public void setPrivateAddr(String privateAddr) {
      this.privateAddr = privateAddr;
   }

   public QueryParams getQps() {
      return this.qps;
   }

   public void setQps(QueryParams qps) {
      this.qps = qps;
   }

   public List<Filter> getFilterList() {
      return this.filterList;
   }

   public void setFilterList(List<Filter> filterList) {
      this.filterList = filterList;
   }

   public String getTopOauth() {
      return this.topOauth;
   }

   public void setTopOauth(String topOauth, boolean force) {
      if (force) {
         this.topOauth = topOauth;
      }

   }

   public Integer getCurrentCount() {
      return this.currentCount;
   }

   public void setCurrentCount(Integer currentCount) {
      this.currentCount = currentCount;
   }

   public String getFilterType() {
      return this.filterType;
   }

   public void setFilterType(String filterType) {
      this.filterType = filterType;
   }

   public String getFilterParm1() {
      return this.filterParm1;
   }

   public void setFilterParm1(String filterParm1) {
      this.filterParm1 = filterParm1;
   }

   public String getFilterParm2() {
      return this.filterParm2;
   }

   public void setFilterParm2(String filterParm2) {
      this.filterParm2 = filterParm2;
   }

   public String getFilterParm3() {
      return this.filterParm3;
   }

   public void setFilterParm3(String filterParm3) {
      this.filterParm3 = filterParm3;
   }

   public List<String> getFilterParms() {
      return this.filterParms;
   }

   public void setFilterParms(List<String> filterParms) {
      this.filterParms = filterParms;
   }

   public String getLogin() {
      if ("Y".equals(this.anonymousFlag) && UserUtil.getUser() == null) {
         return "0-1";
      } else {
         CoreUser user = UserUtil.getUser();
         if (user != null) {
            String tempLogin = user.getId();
            if (this.login != null && !"".equals(this.login)) {
               return this.login;
            } else {
               return tempLogin == null ? "invalid login" : String.valueOf(tempLogin);
            }
         } else {
            return "";
         }
      }
   }

   public void setLogin(String login) {
      this.login = login;
   }

   public String getBasicOrgId() {
      CoreUser user = UserUtil.getUser();
      if ("Y".equals(this.anonymousFlag) && user == null) {
         return "0";
      } else if (null == user) {
         return "0";
      } else {
         String orgId = user.getOrgId();
         if (this.basicOrgId == null) {
            return orgId == null ? "0" : orgId;
         } else {
            return this.basicOrgId;
         }
      }
   }

   public void setBasicOrgId(String basicOrgId) {
      this.basicOrgId = basicOrgId;
   }

   public String getBasicPostnId() {
      CoreUser user = UserUtil.getUser();
      if ("Y".equals(this.anonymousFlag) && user == null) {
         return "0";
      } else if (null == user) {
         return "0";
      } else {
         String positionId = user.getPostnId();
         if (this.basicPostnId == null) {
            return positionId == null ? "0" : positionId;
         } else {
            return this.basicPostnId;
         }
      }
   }

   public void setBasicPostnId(String basicPostnId) {
      this.basicPostnId = basicPostnId;
   }

   public void installCreateData() {
      CoreUser user = UserUtil.getUser();
      String userId = user.getId();
      this.created = DateUtil.dateToStr(new Date(), "yyyy-MM-dd HH:mm:ss");
      this.lastUpdated = this.created;
      this.createdBy = userId == null ? "0" : userId;
      this.lastUpdatedBy = this.createdBy;
      Long loginCorpId = user.getCorpid();
      this.corpid = loginCorpId == null ? 0L : loginCorpId;
   }

   public String getLoginType() {
      CoreUser user = UserUtil.getUser();
      return user != null && StringUtils.isNotBlank(user.getLoginType()) ? user.getLoginType() : null;
   }

   public void setLoginType(String loginType) {
      this.loginType = loginType;
   }

   public Integer getRowVersion() {
      return this.rowVersion;
   }

   public void setRowVersion(Integer rowVersion) {
      this.rowVersion = rowVersion;
   }

   public Boolean getSelectedFlag() {
      return this.selectedFlag;
   }

   public void setSelectedFlag(Boolean selectedFlag) {
      this.selectedFlag = selectedFlag;
   }

   public Object deepClone() throws IOException, ClassNotFoundException {
      ByteArrayOutputStream bos = new ByteArrayOutputStream();
      ObjectOutputStream oos = new ObjectOutputStream(bos);
      oos.writeObject(this);
      ByteArrayInputStream bis = new ByteArrayInputStream(bos.toByteArray());
      ObjectInputStream ois = new ObjectInputStream(bis);
      return ois.readObject();
   }

   public String getUpdateFields() {
      return this.updateFields;
   }

   public void setUpdateFields(String updateFields) {
      this.updateFields = updateFields;
   }

   public List<Map<String, String>> getReportResult() {
      return this.reportResult;
   }

   public void setReportResult(List<Map<String, String>> reportResult) {
      this.reportResult = reportResult;
   }

   public String getSqlAndCorpId() {
      return CoreYmlConstants.getSqlAndCorpId();
   }

   public void setSqlAndCorpId(String sqlAndCorpId) {
      this.sqlAndCorpId = sqlAndCorpId;
   }

   public String getFilterOperator() {
      return this.filterOperator;
   }

   public void setFilterOperator(String filterOperator) {
      this.filterOperator = filterOperator;
   }

   public String getReloadCache() {
      return this.reloadCache;
   }

   public void setReloadCache(String reloadCache) {
      this.reloadCache = reloadCache;
   }

   public String getOrgSecuritySourceId() {
      return this.orgSecuritySourceId;
   }

   public void setOrgSecuritySourceId(String orgSecuritySourceId) {
      this.orgSecuritySourceId = orgSecuritySourceId;
   }

   public String getPostnSecuritySourceId() {
      return this.postnSecuritySourceId;
   }

   public void setPostnSecuritySourceId(String postnSecuritySourceId) {
      this.postnSecuritySourceId = postnSecuritySourceId;
   }

   public String getExportMethod() {
      return this.exportMethod;
   }

   public void setExportMethod(String exportMethod) {
      this.exportMethod = exportMethod;
   }

   public String getExportMethodParam() {
      return this.exportMethodParam;
   }

   public void setExportMethodParam(String exportMethodParam) {
      this.exportMethodParam = exportMethodParam;
   }

   public String getPositionType() {
      return this.positionType;
   }

   public void setPositionType(String positionType) {
      this.positionType = positionType;
   }

   public int getExportTotal() {
      return this.exportTotal;
   }

   public void setExportTotal(int exportTotal) {
      this.exportTotal = exportTotal;
   }

   public Long getLastId() {
      return this.lastId;
   }

   public void setLastId(Long lastId) {
      this.lastId = lastId;
   }

   @JsonIgnore
   public String getCacheParam() {
      return this.cacheParam;
   }

   public void setCacheParam(String cacheParam) {
      this.cacheParam = cacheParam;
   }

   public String getEsDocShipFlag() {
      return this.esDocShipFlag;
   }

   public void setEsDocShipFlag(String esDocShipFlag) {
      this.esDocShipFlag = esDocShipFlag;
   }

   public String getEsDocShipMark() {
      return this.esDocShipMark;
   }

   public void setEsDocShipMark(String esDocShipMark) {
      this.esDocShipMark = esDocShipMark;
   }

   public boolean getStreamFlag() {
      return this.streamFlag;
   }

   public void setStreamFlag(boolean streamFlag) {
      this.streamFlag = streamFlag;
   }
}
